/*********************************************************************************************************************
* DAVE APP Name : INTERRUPT       APP Version: 4.0.8
*
* NOTE:
* This file is generated by DAVE. Any manual modification done to this file will be lost when the code is regenerated.
*********************************************************************************************************************/

/**
 * @cond
 ***********************************************************************************************************************
 *
 * Copyright (c) 2015, Infineon Technologies AG
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,are permitted provided that the
 * following conditions are met:
 *
 *   Redistributions of source code must retain the above copyright notice, this list of conditions and the  following
 *   disclaimer.
 *
 *   Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the
 *   following disclaimer in the documentation and/or other materials provided with the distribution.
 *
 *   Neither the name of the copyright holders nor the names of its contributors may be used to endorse or promote
 *   products derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE  FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY,OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT  OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * To improve the quality of the software, users are encouraged to share modifications, enhancements or bug fixes
 * with Infineon Technologies AG (dave@infineon.com).
 ***********************************************************************************************************************
 *
 * Change History
 * --------------
 *
 * 2015-02-16:
 *     - Initial version<br>
 *
 * 2015-05-08:
 *     - subpriority field is biased based on xmc4 family<br>
 *
 * 2015-07-30:
 *     - Interrupt source is added in config structure
 *
 * 2015-09-18:
 *     - Moved config structure elements to APP structure
 * @endcond
 *
 */

/***********************************************************************************************************************
 * HEADER FILES
 **********************************************************************************************************************/

#include "interrupt.h"

/***********************************************************************************************************************
 * DATA STRUCTURES
 **********************************************************************************************************************/

const INTERRUPT_t TICKS_TIMER_INTERRUPT =
{
#if(UC_SERIES == XMC14)
 .irqctrl = (XMC_SCU_IRQCTRL_t)0U,
#endif
  .node = (IRQn_Type)44,
  .priority = 63,  
#if(UC_FAMILY == XMC4)  
  .subpriority = 0,
#endif  

  .enable_at_init = true

};
const INTERRUPT_t CAM_LOW_INTERRUPT =
{
#if(UC_SERIES == XMC14)
 .irqctrl = (XMC_SCU_IRQCTRL_t)0U,
#endif
  .node = (IRQn_Type)45,
  .priority = 63,  
#if(UC_FAMILY == XMC4)  
  .subpriority = 0,
#endif  

  .enable_at_init = true

};
const INTERRUPT_t CAM_HIGH_INTERRUPT =
{
#if(UC_SERIES == XMC14)
 .irqctrl = (XMC_SCU_IRQCTRL_t)0U,
#endif
  .node = (IRQn_Type)46,
  .priority = 63,  
#if(UC_FAMILY == XMC4)  
  .subpriority = 0,
#endif  

  .enable_at_init = true

};
const INTERRUPT_t CRANK_LOW_INTERRUPT1 =
{
#if(UC_SERIES == XMC14)
 .irqctrl = (XMC_SCU_IRQCTRL_t)0U,
#endif
  .node = (IRQn_Type)51,
  .priority = 63,  
#if(UC_FAMILY == XMC4)  
  .subpriority = 0,
#endif  

  .enable_at_init = true

};
const INTERRUPT_t CRANK_HIGH_INTERRUPT1 =
{
#if(UC_SERIES == XMC14)
 .irqctrl = (XMC_SCU_IRQCTRL_t)0U,
#endif
  .node = (IRQn_Type)49,
  .priority = 63,  
#if(UC_FAMILY == XMC4)  
  .subpriority = 0,
#endif  

  .enable_at_init = true

};
const INTERRUPT_t CRANK_LOW_INTERRUPT2 =
{
#if(UC_SERIES == XMC14)
 .irqctrl = (XMC_SCU_IRQCTRL_t)0U,
#endif
  .node = (IRQn_Type)48,
  .priority = 63,  
#if(UC_FAMILY == XMC4)  
  .subpriority = 0,
#endif  

  .enable_at_init = true

};
const INTERRUPT_t CRANK_HIGH_INTERRUPT2 =
{
#if(UC_SERIES == XMC14)
 .irqctrl = (XMC_SCU_IRQCTRL_t)0U,
#endif
  .node = (IRQn_Type)50,
  .priority = 63,  
#if(UC_FAMILY == XMC4)  
  .subpriority = 0,
#endif  

  .enable_at_init = true

};
const INTERRUPT_t INJ1_INTERRUPT =
{
#if(UC_SERIES == XMC14)
 .irqctrl = (XMC_SCU_IRQCTRL_t)0U,
#endif
  .node = (IRQn_Type)56,
  .priority = 63,  
#if(UC_FAMILY == XMC4)  
  .subpriority = 0,
#endif  

  .enable_at_init = true

};
const INTERRUPT_t INJ2_INTERRUPT =
{
#if(UC_SERIES == XMC14)
 .irqctrl = (XMC_SCU_IRQCTRL_t)0U,
#endif
  .node = (IRQn_Type)58,
  .priority = 63,  
#if(UC_FAMILY == XMC4)  
  .subpriority = 0,
#endif  

  .enable_at_init = true

};
const INTERRUPT_t INJ3_INTERRUPT =
{
#if(UC_SERIES == XMC14)
 .irqctrl = (XMC_SCU_IRQCTRL_t)0U,
#endif
  .node = (IRQn_Type)59,
  .priority = 63,  
#if(UC_FAMILY == XMC4)  
  .subpriority = 0,
#endif  

  .enable_at_init = true

};
const INTERRUPT_t INJ5_INTERRUPT =
{
#if(UC_SERIES == XMC14)
 .irqctrl = (XMC_SCU_IRQCTRL_t)0U,
#endif
  .node = (IRQn_Type)53,
  .priority = 63,  
#if(UC_FAMILY == XMC4)  
  .subpriority = 0,
#endif  

  .enable_at_init = true

};
const INTERRUPT_t INJ6_INTERRUPT =
{
#if(UC_SERIES == XMC14)
 .irqctrl = (XMC_SCU_IRQCTRL_t)0U,
#endif
  .node = (IRQn_Type)52,
  .priority = 63,  
#if(UC_FAMILY == XMC4)  
  .subpriority = 0,
#endif  

  .enable_at_init = true

};
const INTERRUPT_t INJ4_INTERRUPT =
{
#if(UC_SERIES == XMC14)
 .irqctrl = (XMC_SCU_IRQCTRL_t)0U,
#endif
  .node = (IRQn_Type)57,
  .priority = 63,  
#if(UC_FAMILY == XMC4)  
  .subpriority = 0,
#endif  

  .enable_at_init = true

};
