/*
 *  Starts times when injectors are driven from car ECU
 */

#include "READ_ANALOGUES.h"


void Adc_Handler()
{
	ADCDataAvailable = 1;

}

void Adc_Calc()
{

	float tempVal;
	float x = 2.5;        //scale factor - (range of value/range of voltage)/(adc steps per volt) = (2300/4.5)/204
	float y = 61;         //sensor voltage (ADC Bits) input range low (from liner graph)
	float z = 200;        //voltage in low limit - sensor value output range low (from liner graph)
	float calib = -60;    //calibration offset
	float tempVal2;       //for wide band


	tempVal = ADC_MEASUREMENT_GetResult(&ADC_MEASUREMENT_Manifold_Pressure_handle);
	tempVal = ((tempVal - y) * x) + z;
	tempVal = tempVal- 1000;
	manifoldPress = tempVal; //tempVal + calib;      // calibrate sensor

	tempVal2 = ADC_MEASUREMENT_GetResult(&ADC_MEASUREMENT_Wide_Band_handle);
	tempVal2 = tempVal2 * 0.000664;
	tempVal2 = tempVal2 + 0.68;
	tempVal2 = tempVal2 * 100;  // avoid using floats
	wideBandLambda = tempVal2;  // result is lambda * 100

	tempVal2 = ADC_MEASUREMENT_GetResult(&ADC_MEASUREMENT_Lambda_Temp_handle); // read temperature from lambda controller. Output is a 8 bit dac. 2 dac steps = 1°C. 0v =700°C
	tempVal2 = tempVal2 / 8;
	tempVal2 = tempVal2 + 700;
	tempVal2 = tempVal2 + 5; //calibrate
	lambdaTemp = tempVal2;  // result is temp °C

}
