/*
 *
 *
 * * Calculates delay time for cam and crank pulses from fuel map in us x 100 to feed directly into timers
 *
 *
 */

#include "CALC_TIMING_DELAY.h"


int32_t camDelay(int32_t x, int32_t y)  // x = cam delay angle (° x 100), y = RPM)
{
	y = 1000000 / (y / 120);     // us per revolution of cam shaft
	y = (((float)y / 360) * x);  //pulse shift

	if(y < 20)                  //stop output going too low for timer to handle
	{
		y = 20;
	}

	return y;

}

int32_t crankDelay(int32_t x)   // returns timing shift for crank pulses
{
	x = x / 2;
	return x;
}
