/*
 *  Controls cam output and calculates RPM based on cam signal
 */

#include "CAM_CONTROL.h"


void CamInput()
{


	if (PIN_INTERRUPT_GetPinValue(&CAM_SENSOR)) // Cam inductive pickup goes high
	{

		uint32_t tempVal;
		tempVal = TIMER_GetTime(&CAM_RPM_TIME);
		TIMER_Clear(&CAM_RPM_TIME);
		tempVal = tempVal / 100;               // timer result is time * 100? remove if nots
	    tempVal = (100000000/tempVal) / (float)2.5;       // calc RPM from cam timing pulse. Cam trigger wheel has 3 teeth. 1 turn of cam = 2 turns of crank
		RPM = tempVal;

	    TIMER_Stop(&CAM_HIGH_TIMER);                       // Configure timer to turn on cam output
	    TIMER_SetTimeInterval(&CAM_HIGH_TIMER, camDelayTime);    // add value from RPM map
	    TIMER_Clear(&CAM_HIGH_TIMER);
	    TIMER_Start(&CAM_HIGH_TIMER);

	}

	if (!PIN_INTERRUPT_GetPinValue(&CAM_SENSOR)) // Cam inductive pickup goes low
	{
	    TIMER_Stop(&CAM_LOW_TIMER);                       // Configure timer to turn on cam output
	    TIMER_SetTimeInterval(&CAM_LOW_TIMER, camDelayTime);    // add value from RPM map
	    TIMER_Clear(&CAM_LOW_TIMER);
	    TIMER_Start(&CAM_LOW_TIMER);
	}
}

void CamHighTimerDone()
{
	DIGITAL_IO_SetOutputHigh(&CAM_OUTPUT); // turn on cam output
    TIMER_Stop(&CAM_HIGH_TIMER);
}

void CamLowTimerDone()
{
	DIGITAL_IO_SetOutputLow(&CAM_OUTPUT); // turn on cam output
    TIMER_Stop(&CAM_LOW_TIMER);
}

