/*
 *  Controls crank output. Uses two on and off timers to ensure that signals never overlap
 */

#include "CRANK_CONTROL.h"
#include <stdlib.h>
#include <stdio.h>

void CrankInput()
{

	if(useCrankTimer == 0)
	{

	if (PIN_INTERRUPT_GetPinValue(&CRANK_SENSOR)) // Crank inductive pickup goes high
	{

	    TIMER_Stop(&CRANK_HIGH_TIMER_1);                       // Configure timer to turn on cam output
	    TIMER_SetTimeInterval(&CRANK_HIGH_TIMER_1, crankDelayTime);    // add value from RPM map
	    TIMER_Clear(&CRANK_HIGH_TIMER_1);
	    TIMER_Start(&CRANK_HIGH_TIMER_1);

	}

	if (!PIN_INTERRUPT_GetPinValue(&CRANK_SENSOR)) // Crank inductive pickup goes low
	{
	    TIMER_Stop(&CRANK_LOW_TIMER_1);                       // Configure timer to turn on cam output
	    TIMER_SetTimeInterval(&CRANK_LOW_TIMER_1, crankDelayTime);    // add value from RPM map
	    TIMER_Clear(&CRANK_LOW_TIMER_1);
	    TIMER_Start(&CRANK_LOW_TIMER_1);
	    useCrankTimer = 1;
	}
	}

	if(useCrankTimer != 0)
	{

	if (PIN_INTERRUPT_GetPinValue(&CRANK_SENSOR)) // Crank inductive pickup goes high
	{

	    TIMER_Stop(&CRANK_HIGH_TIMER_2);                       // Configure timer to turn on cam output
	    TIMER_SetTimeInterval(&CRANK_HIGH_TIMER_2, crankDelayTime);    // add value from RPM map
	    TIMER_Clear(&CRANK_HIGH_TIMER_2);
	    TIMER_Start(&CRANK_HIGH_TIMER_2);

	}

	if (!PIN_INTERRUPT_GetPinValue(&CRANK_SENSOR)) // Crank inductive pickup goes low
	{
	    TIMER_Stop(&CRANK_LOW_TIMER_2);                       // Configure timer to turn on cam output
	    TIMER_SetTimeInterval(&CRANK_LOW_TIMER_2, crankDelayTime);    // add value from RPM map
	    TIMER_Clear(&CRANK_LOW_TIMER_2);
	    TIMER_Start(&CRANK_LOW_TIMER_2);
	    useCrankTimer = 0;
	}
	}

}

void CrankHigh1TimerDone()
{
	DIGITAL_IO_SetOutputHigh(&CRANK_OUTPUT); // turn on Crank output
    TIMER_Stop(&CRANK_HIGH_TIMER_1);
}

void CrankLow1TimerDone()
{
	DIGITAL_IO_SetOutputLow(&CRANK_OUTPUT); // turn off Crank output
    TIMER_Stop(&CRANK_LOW_TIMER_1);
}

void CrankHigh2TimerDone()
{
	DIGITAL_IO_SetOutputHigh(&CRANK_OUTPUT); // turn on Crank output
    TIMER_Stop(&CRANK_HIGH_TIMER_2);
}

void CrankLow2TimerDone()
{
	DIGITAL_IO_SetOutputLow(&CRANK_OUTPUT); // turn off Crank output
    TIMER_Stop(&CRANK_LOW_TIMER_2);
}
